using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using System.Transactions;

namespace SSBExternalActivationRouter
{
    public partial class Form1 : Form
    {
        RouterController _router = new RouterController();

        public Form1()
        {
            InitializeComponent();
        }

        private void Start_Click(object sender, EventArgs e)
        {
            if (radioButton1.Checked)
            {
                _router.Start(StartUpMode.StartMSMQ);
            }
            else
            {
                _router.Start(StartUpMode.StartSQL2000);
            }
        }

        private void Stop_Click(object sender, EventArgs e)
        {
            _router.Stop();
        }

        private void TestTrans_Click(object sender, EventArgs e)
        {
                TransactionScope scope;
                string connectString = "Data Source=TACOBELL;Initial Catalog=TestSSB;Integrated Security=SSPI;";
                SqlParameter param;
                SqlConnection conn;

                conn = new SqlConnection(connectString);

                conn.Open();


                //scope = new TransactionScope(opt,tranOpt,enterpriseOpt);
                scope = new TransactionScope();

                //Begin transaction
                using (scope)
                {
                    conn.EnlistTransaction(System.Transactions.Transaction.Current);

                    SqlCommand cmd = conn.CreateCommand();
                    string query;

                    query = "EXEC InsertTestSSB @body ";
                    cmd.CommandText = query;

                    param = cmd.Parameters.Add("@body", SqlDbType.Text);

                    param.Value = "Test me";

                    cmd.ExecuteNonQuery();

                    scope.Complete();
                }

        }

 
    }
}