using System;
using System.Collections.Generic;
using System.Text;
using System.Messaging;
using System.Xml;

namespace SSBExternalActivationRouter
{
    class TransactedMessageMediator_MSMQ : ITransactedMessageMediator
    {
        MessageQueue _msgQueue;

        public void Translate(SSBMessage msg)
        {
            XmlDocument xml = new XmlDocument();
            xml.Load(msg.Body);

            _msgQueue.Send(xml.OuterXml);

            //You can also do this in a transaction
            //because of distributed issues, what's the point?
        }

        public void Init(object obj)
        {
            _msgQueue = new MessageQueue((string)obj); //Remember to create this Queue
        }

    }
}
